"""
------------------------------------------------------------------------------
The MIT License (MIT)
Copyright (c) 2016 Newcastle University
Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:
The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.import time
------------------------------------------------------------------------------
Author
Kenji Kawase, Artec Co., Ltd. 
We used the script below as reference
https://github.com/casnortheast/microbit_stub/
------------------------------------------------------------------------------
"""
from image import StuduinoBitBuiltInImage
from image import StuduinoBitImage


ANGRY = StuduinoBitBuiltInImage('90009:09090:00000:99999:90909:')
ASLEEP = StuduinoBitBuiltInImage('00000:99099:00000:09990:00000:')
HAPPY = StuduinoBitBuiltInImage('00000:09090:00000:90009:09990:')
SAD = StuduinoBitBuiltInImage('00000:09090:00000:09990:90009:')

ARROW_N = StuduinoBitBuiltInImage('00900:09990:90909:00900:00900:')
ARROW_NE = StuduinoBitBuiltInImage('00999:00099:00909:09000:90000:')
ARROW_E = StuduinoBitBuiltInImage('00900:00090:99999:00090:00900:')
ARROW_SE = StuduinoBitBuiltInImage('90000:09000:00909:00099:00999:')
ARROW_S = StuduinoBitBuiltInImage('00900:00900:90909:09990:00900:')
ARROW_SW = StuduinoBitBuiltInImage('00009:00090:90900:99000:99900:')
ARROW_W = StuduinoBitBuiltInImage('00900:09000:99999:09000:00900:')
ARROW_NW = StuduinoBitBuiltInImage('99900:99000:90900:00090:00009:')

ALL_ARROWS = [
    ARROW_N,
    ARROW_NE,
    ARROW_E,
    ARROW_SE,
    ARROW_S,
    ARROW_SW,
    ARROW_W,
    ARROW_NW,
    ]
    

StuduinoBitImage.ANGRY = ANGRY
StuduinoBitImage.ASLEEP = ASLEEP
StuduinoBitImage.HAPPY = HAPPY
StuduinoBitImage.SAD = SAD

StuduinoBitImage.ARROW_N = ARROW_N
StuduinoBitImage.ARROW_NE = ARROW_NE
StuduinoBitImage.ARROW_E = ARROW_E
StuduinoBitImage.ARROW_SE = ARROW_SE
StuduinoBitImage.ARROW_S = ARROW_S
StuduinoBitImage.ARROW_SW = ARROW_SW
StuduinoBitImage.ARROW_W = ARROW_W
StuduinoBitImage.ARROW_NW = ARROW_NW

StuduinoBitImage.ALL_ARROWS = ALL_ARROWS

CHARACTER_MAP = {
    ' ':'00000:00000:00000:00000:00000:',
    '!':'09000:09000:09000:00000:09000:',
    '"':'09090:09090:00000:00000:00000:',
    '#':'09090:99999:09090:99999:09090:',
    '$':'09990:99009:09990:90099:09990:',
    '%':'99009:90090:00900:09009:90099:',
    '&':'09900:90090:09900:90090:09909:',
    "'":'09000:09000:00000:00000:00000:',
    '(':'00900:09000:09000:09000:00900:',
    ')':'09000:00900:00900:00900:09000:',
    '*':'00000:09090:00900:09090:00000:',
    '+':'00000:00900:09990:00900:00000:',
    ',':'00000:00000:00000:00900:09000:',
    '-':'00000:00000:09990:00000:00000:',
    '.':'00000:00000:00000:09000:00000:',
    '/':'00009:00090:00900:09000:90000:',
    '0':'09900:90090:90090:90090:09900:',
    '1':'00900:09900:00900:00900:09990:',
    '2':'99900:00090:09900:90000:99990:',
    '3':'99990:00090:00900:90090:09900:',
    '4':'00990:09090:90090:99999:00090:',
    '5':'99999:90000:99990:00009:99990:',
    '6':'00090:00900:09990:90009:09990:',
    '7':'99999:00090:00900:09000:90000:',
    '8':'09990:90009:09990:90009:09990:',
    '9':'09990:90009:09990:00900:09000:',
    ':':'00000:09000:00000:09000:00000:',
    ';':'00000:00900:00000:00900:09000:',
    '<':'00090:00900:09000:00900:00090:',
    '=':'00000:09990:00000:09990:00000:',
    '>':'09000:00900:00090:00900:09000:',
    '?':'09990:90009:00990:00000:00900:',
    '@':'09990:90009:90909:90099:09900:',
    'A':'09900:90090:99990:90090:90090:',
    'B':'99900:90090:99900:90090:99900:',
    'C':'09990:90000:90000:90000:09990:',
    'D':'99900:90090:90090:90090:99900:',
    'E':'99990:90000:99900:90000:99990:',
    'F':'99990:90000:99900:90000:90000:',
    'G':'09990:90000:90099:90009:09990:',
    'H':'90090:90090:99990:90090:90090:',
    'I':'99900:09000:09000:09000:99900:',
    'J':'99999:00090:00090:90090:09900:',
    'K':'90090:90900:99000:90900:90090:',
    'L':'90000:90000:90000:90000:99990:',
    'M':'90009:99099:90909:90009:90009:',
    'N':'90009:99009:90909:90099:90009:',
    'O':'09900:90090:90090:90090:09900:',
    'P':'99900:90090:99900:90000:90000:',
    'Q':'09900:90090:90090:09900:00990:',
    'R':'99900:90090:99900:90090:90009:',
    'S':'09990:90000:09900:00090:99900:',
    'T':'99999:00900:00900:00900:00900:',
    'U':'90090:90090:90090:90090:09900:',
    'V':'90009:90009:90009:09090:00900:',
    'W':'90009:90009:90909:99099:90009:',
    'X':'90090:90090:09900:90090:90090:',
    'Y':'90009:09090:00900:00900:00900:',
    'Z':'99990:00900:09000:90000:99990:',
    '[':'09990:09000:09000:09000:09990:',
    '\\':'90000:09000:00900:00090:00009:',
    ']':'09990:00090:00090:00090:09990:',
    '^':'00900:09090:00000:00000:00000:',
    '_':'00000:00000:00000:00000:99999:',
    '`':'09000:00900:00000:00000:00000:',
    'a':'00000:09990:90090:90090:09999:',
    'b':'90000:90000:99900:90090:99900:',
    'c':'00000:09990:90000:90000:09990:',
    'd':'00090:00090:09990:90090:09990:',
    'e':'09900:90090:99900:90000:09990:',
    'f':'00990:09000:99900:09000:09000:',
    'g':'09990:90090:09990:00090:09900:',
    'h':'90000:90000:99900:90090:90090:',
    'i':'09000:00000:09000:09000:09000:',
    'j':'00090:00000:00090:00090:09900:',
    'k':'90000:90900:99000:90900:90090:',
    'l':'09000:09000:09000:09000:00990:',
    'm':'00000:99099:90909:90009:90009:',
    'n':'00000:99900:90090:90090:90090:',
    'o':'00000:09900:90090:90090:09900:',
    'p':'00000:99900:90090:99900:90000:',
    'q':'00000:09990:90090:09990:00090:',
    'r':'00000:09990:90000:90000:90000:',
    's':'00000:00990:09000:00900:99000:',
    't':'09000:09000:09990:09000:00999:',
    'u':'00000:90090:90090:90090:09999:',
    'v':'00000:90009:90009:09090:00900:',
    'w':'00000:90009:90009:90909:99099:',
    'x':'00000:90090:09900:09900:90090:',
    'y':'00000:90009:09090:00900:99000:',
    'z':'00000:99990:00900:09000:99990:',
    '{':'00990:00900:09900:00900:00990:',
    '|':'09000:09000:09000:09000:09000:',
    '}':'99000:09000:09900:09000:99000:',
    '~':'00000:00000:09900:00099:00000:',
    }

StuduinoBitImage.CHARACTER_MAP = CHARACTER_MAP







